- [HTTP request](https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/rawEncrypt#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/rawEncrypt#body.PATH_PARAMETERS)
- [Request body](https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/rawEncrypt#body.request_body)
  - [JSON representation](https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/rawEncrypt#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/rawEncrypt#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/rawEncrypt#body.RawEncryptResponse.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/rawEncrypt#body.aspect)
- [Try it!](https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/rawEncrypt#try-it)

**Full name**: projects.locations.keyRings.cryptoKeys.cryptoKeyVersions.rawEncrypt

Encrypts data using portable cryptographic primitives. Most users should choose `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys/encrypt#google.cloud.kms.v1.KeyManagementService.Encrypt` and `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys/decrypt#google.cloud.kms.v1.KeyManagementService.Decrypt` rather than their raw counterparts. The `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys#CryptoKey.FIELDS.purpose` must be `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys#CryptoKeyPurpose.ENUM_VALUES.RAW_ENCRYPT_DECRYPT`.

### HTTP request

Choose an endpoint:
global europe-west6 us-east7 europe-west3 us-west8 europe-west9 me-central2 us-east1 us-west1 us-west3 us-central2 us-east4 us-west2 europe-west8 us-central1 us-west4 us-east5 us-south1 northamerica-northeast1 northamerica-northeast2 us in ca   
`POST https://cloudkms.googleapis.com/v1/{name=projects/*/locations/*/keyRings/*/cryptoKeys/*/cryptoKeyVersions/*}:rawEncrypt`

<br />

The URLs use [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `name` | `string` Required. The resource name of the `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions#CryptoKeyVersion` to use for encryption. Authorization requires the following [IAM](https://cloud.google.com/iam/docs/) permission on the specified resource `name`: - `cloudkms.cryptoKeyVersions.useToEncrypt` |

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "plaintext": string, "additionalAuthenticatedData": string, "plaintextCrc32c": string, "additionalAuthenticatedDataCrc32c": string, "initializationVector": string, "initializationVectorCrc32c": string } ``` |

| Fields ||
|---|---|
| `plaintext` | `string (https://developers.google.com/discovery/v1/type-format format)` Required. The data to encrypt. Must be no larger than 64KiB. The maximum size depends on the key version's `https://docs.cloud.google.com/kms/docs/reference/rest/v1/ProtectionLevel`. For `https://docs.cloud.google.com/kms/docs/reference/rest/v1/ProtectionLevel#ENUM_VALUES.SOFTWARE` keys, the plaintext must be no larger than 64KiB. For `https://docs.cloud.google.com/kms/docs/reference/rest/v1/ProtectionLevel#ENUM_VALUES.HSM` keys, the combined length of the plaintext and additionalAuthenticatedData fields must be no larger than 8KiB. A base64-encoded string. |
| `additionalAuthenticatedData` | `string (https://developers.google.com/discovery/v1/type-format format)` Optional. Optional data that, if specified, must also be provided during decryption through `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/rawDecrypt#body.request_body.FIELDS.additional_authenticated_data`. This field may only be used in conjunction with an `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions#CryptoKeyVersion.FIELDS.algorithm` that accepts additional authenticated data (for example, AES-GCM). The maximum size depends on the key version's `https://docs.cloud.google.com/kms/docs/reference/rest/v1/ProtectionLevel`. For `https://docs.cloud.google.com/kms/docs/reference/rest/v1/ProtectionLevel#ENUM_VALUES.SOFTWARE` keys, the plaintext must be no larger than 64KiB. For `https://docs.cloud.google.com/kms/docs/reference/rest/v1/ProtectionLevel#ENUM_VALUES.HSM` keys, the combined length of the plaintext and additionalAuthenticatedData fields must be no larger than 8KiB. A base64-encoded string. |
| `plaintextCrc32c` | `string (https://developers.google.com/discovery/v1/type-format format)` Optional. An optional CRC32C checksum of the `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/rawEncrypt#body.request_body.FIELDS.plaintext`. If specified, `KeyManagementService` will verify the integrity of the received plaintext using this checksum. `KeyManagementService` will report an error if the checksum verification fails. If you receive a checksum error, your client should verify that CRC32C(plaintext) is equal to plaintextCrc32c, and if so, perform a limited number of retries. A persistent mismatch may indicate an issue in your computation of the CRC32C checksum. Note: This field is defined as int64 for reasons of compatibility across different languages. However, it is a non-negative integer, which will never exceed 2\^32-1, and can be safely downconverted to uint32 in languages that support this type. |
| `additionalAuthenticatedDataCrc32c` | `string (https://developers.google.com/discovery/v1/type-format format)` Optional. An optional CRC32C checksum of the `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/rawEncrypt#body.request_body.FIELDS.additional_authenticated_data`. If specified, `KeyManagementService` will verify the integrity of the received additionalAuthenticatedData using this checksum. `KeyManagementService` will report an error if the checksum verification fails. If you receive a checksum error, your client should verify that CRC32C(additionalAuthenticatedData) is equal to additionalAuthenticatedDataCrc32c, and if so, perform a limited number of retries. A persistent mismatch may indicate an issue in your computation of the CRC32C checksum. Note: This field is defined as int64 for reasons of compatibility across different languages. However, it is a non-negative integer, which will never exceed 2\^32-1, and can be safely downconverted to uint32 in languages that support this type. |
| `initializationVector` | `string (https://developers.google.com/discovery/v1/type-format format)` Optional. A customer-supplied initialization vector that will be used for encryption. If it is not provided for AES-CBC and AES-CTR, one will be generated. It will be returned in `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/rawEncrypt#body.RawEncryptResponse.FIELDS.initialization_vector`. A base64-encoded string. |
| `initializationVectorCrc32c` | `string (https://developers.google.com/discovery/v1/type-format format)` Optional. An optional CRC32C checksum of the `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/rawEncrypt#body.request_body.FIELDS.initialization_vector`. If specified, `KeyManagementService` will verify the integrity of the received initializationVector using this checksum. `KeyManagementService` will report an error if the checksum verification fails. If you receive a checksum error, your client should verify that CRC32C(initializationVector) is equal to initializationVectorCrc32c, and if so, perform a limited number of retries. A persistent mismatch may indicate an issue in your computation of the CRC32C checksum. Note: This field is defined as int64 for reasons of compatibility across different languages. However, it is a non-negative integer, which will never exceed 2\^32-1, and can be safely downconverted to uint32 in languages that support this type. |

### Response body

Response message for `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/rawEncrypt#google.cloud.kms.v1.KeyManagementService.RawEncrypt`.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "ciphertext": string, "initializationVector": string, "tagLength": integer, "ciphertextCrc32c": string, "initializationVectorCrc32c": string, "verifiedPlaintextCrc32c": boolean, "verifiedAdditionalAuthenticatedDataCrc32c": boolean, "verifiedInitializationVectorCrc32c": boolean, "name": string, "protectionLevel": enum (`https://docs.cloud.google.com/kms/docs/reference/rest/v1/ProtectionLevel`) } ``` |

| Fields ||
|---|---|
| `ciphertext` | `string (https://developers.google.com/discovery/v1/type-format format)` The encrypted data. In the case of AES-GCM, the authentication tag is the `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/rawEncrypt#body.RawEncryptResponse.FIELDS.tag_length` bytes at the end of this field. A base64-encoded string. |
| `initializationVector` | `string (https://developers.google.com/discovery/v1/type-format format)` The initialization vector (IV) generated by the service during encryption. This value must be stored and provided in `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/rawDecrypt#body.request_body.FIELDS.initialization_vector` at decryption time. A base64-encoded string. |
| `tagLength` | `integer` The length of the authentication tag that is appended to the end of the ciphertext. |
| `ciphertextCrc32c` | `string (https://developers.google.com/discovery/v1/type-format format)` Integrity verification field. A CRC32C checksum of the returned `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/rawEncrypt#body.RawEncryptResponse.FIELDS.ciphertext`. An integrity check of ciphertext can be performed by computing the CRC32C checksum of ciphertext and comparing your results to this field. Discard the response in case of non-matching checksum values, and perform a limited number of retries. A persistent mismatch may indicate an issue in your computation of the CRC32C checksum. Note: This field is defined as int64 for reasons of compatibility across different languages. However, it is a non-negative integer, which will never exceed 2\^32-1, and can be safely downconverted to uint32 in languages that support this type. |
| `initializationVectorCrc32c` | `string (https://developers.google.com/discovery/v1/type-format format)` Integrity verification field. A CRC32C checksum of the returned `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/rawEncrypt#body.RawEncryptResponse.FIELDS.initialization_vector`. An integrity check of initializationVector can be performed by computing the CRC32C checksum of initializationVector and comparing your results to this field. Discard the response in case of non-matching checksum values, and perform a limited number of retries. A persistent mismatch may indicate an issue in your computation of the CRC32C checksum. Note: This field is defined as int64 for reasons of compatibility across different languages. However, it is a non-negative integer, which will never exceed 2\^32-1, and can be safely downconverted to uint32 in languages that support this type. |
| `verifiedPlaintextCrc32c` | `boolean` Integrity verification field. A flag indicating whether `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/rawEncrypt#body.request_body.FIELDS.plaintext_crc32c` was received by `KeyManagementService` and used for the integrity verification of the plaintext. A false value of this field indicates either that `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/rawEncrypt#body.request_body.FIELDS.plaintext_crc32c` was left unset or that it was not delivered to `KeyManagementService`. If you've set `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/rawEncrypt#body.request_body.FIELDS.plaintext_crc32c` but this field is still false, discard the response and perform a limited number of retries. |
| `verifiedAdditionalAuthenticatedDataCrc32c` | `boolean` Integrity verification field. A flag indicating whether `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/rawEncrypt#body.request_body.FIELDS.additional_authenticated_data_crc32c` was received by `KeyManagementService` and used for the integrity verification of additionalAuthenticatedData. A false value of this field indicates either that // `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/rawEncrypt#body.request_body.FIELDS.additional_authenticated_data_crc32c` was left unset or that it was not delivered to `KeyManagementService`. If you've set `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/rawEncrypt#body.request_body.FIELDS.additional_authenticated_data_crc32c` but this field is still false, discard the response and perform a limited number of retries. |
| `verifiedInitializationVectorCrc32c` | `boolean` Integrity verification field. A flag indicating whether `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/rawEncrypt#body.request_body.FIELDS.initialization_vector_crc32c` was received by `KeyManagementService` and used for the integrity verification of initializationVector. A false value of this field indicates either that `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/rawEncrypt#body.request_body.FIELDS.initialization_vector_crc32c` was left unset or that it was not delivered to `KeyManagementService`. If you've set `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions/rawEncrypt#body.request_body.FIELDS.initialization_vector_crc32c` but this field is still false, discard the response and perform a limited number of retries. |
| `name` | `string` The resource name of the `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions#CryptoKeyVersion` used in encryption. Check this field to verify that the intended resource was used for encryption. |
| `protectionLevel` | ``enum (`https://docs.cloud.google.com/kms/docs/reference/rest/v1/ProtectionLevel`)`` The `https://docs.cloud.google.com/kms/docs/reference/rest/v1/ProtectionLevel` of the `https://docs.cloud.google.com/kms/docs/reference/rest/v1/projects.locations.keyRings.cryptoKeys.cryptoKeyVersions#CryptoKeyVersion` used in encryption. |

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/cloudkms`
- `https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).